% version 30/07/2003
% refraction.pro
/tx@RefractionDict 100 dict def
tx@RefractionDict begin
% coordonnes du point virtuellement observ
/F1 {
     /M1 xI1 xa sub abs xI1 xa sub dup mul ya dup mul add sqrt div n mul def
     /M2 xI1 xB1 sub abs xI1 xB1 sub dup mul yB1 dup mul add sqrt div def
      M1 M2 sub
    } def
/F2 {
     /M1 xI2 xa sub abs xI2 xa sub dup mul ya dup mul add sqrt div n mul def
     /M2 xI2 xB2 sub abs xI2 xB2 sub dup mul yB2 dup mul add sqrt div def
      M1 M2 sub
    } def
      %
/Coor_Virtuel {
   /xR1 xa def
   /xR2 xB1 def
{
 /xM xR1 xR2 add 2 div def
   /xI1 xR1 def
   /F_1 F1 def
   /xI1 xM def
   /F_M F1 def
   F_M 0 eq {exit} if
    F_1 F_M mul 0 ge {/xR1 xM def}
                     {/xR2 xM def}
    ifelse
 xR1 xR2 sub abs 1e-4 le {exit} if
} loop
/xI1 xM def
%
   /xR1 xa def
   /xR2 xB2 def
{
 /xM xR1 xR2 add 2 div def
   /xI2 xR1 def
   /F_1 F2 def
   /xI2 xM def
   /F_M F2 def
   F_M 0 eq {exit} if
    F_1 F_M mul 0 ge {/xR1 xM def}
                     {/xR2 xM def}
    ifelse
 xR1 xR2 sub abs 1e-4 le {exit} if
} loop
/xI2 xM def
% coordonnes du point virtuellement observ
      xB1 xI1 eq {
        /x_V xI1 def
        /y_V x_V xI2 sub xB2 xI2 sub div yB2 mul def }
      {
       xB2 xI2 eq {
        /x_V xI2 def
        /y_V x_V xI1 sub xB1 xI1 sub div yB1 mul def }
       {
      /Coeff_a1 yB1 xB1 xI1 sub div def
      /Coeff_b1 Coeff_a1 xI1 mul neg def
      /Coeff_a2 yB2 xB2 xI2 sub div def
      /Coeff_b2 Coeff_a2 xI2 mul neg def
      /x_V Coeff_b1 Coeff_b2 sub Coeff_a1 Coeff_a2 sub div
      neg def
      /y_V x_V Coeff_a1 mul Coeff_b1 add def
      } ifelse
      } ifelse
      x_V y_V } def
%
/Parameters {%
    /n ED
    /eyewidth ED
    /xMilieu ED
    /yb ED
    /xb ED } def
/positionOEIL{
    xb xMilieu eq { /DistanceYB1YB2 0 def }
    {/DistanceYB1YB2 eyewidth xMilieu xb sub dup mul
      xMilieu xb sub dup mul yb dup mul add
      div sqrt mul def }
    ifelse
   /yB1 yb DistanceYB1YB2 sub def
   /yB2 yb DistanceYB1YB2 add def
   xMilieu xb eq {
    /xB1 xMilieu eyewidth sub def
    /xB2 xMilieu eyewidth add def
    }
   {/xB1 yb yB1 yb sub mul xMilieu xb sub div xb add def
    /xB2 yb yB2 yb sub mul xMilieu xb sub div xb add def
   }
   ifelse
    } def
% tracer une ligne entre deux points
/LineAB {/YB ED /XB ED /YA ED /XA ED} def
/StartLine {%
    /xa XA def
    /ya YA def
    Coor_Virtuel
    moveto }
    def
%
/CalcLine {%
    0 1 100 {%
    /kp exch 100 div def
    /xa XA kp XB XA sub mul add def
    /ya YA kp YB YA sub mul add def
    Coor_Virtuel
    lineto
    }
    for
} def
%
/traceLine {%
    Parameters
    positionOEIL
    LineAB
    StartLine
    CalcLine
    }
    def
% Tableau de points
/DessinCercle {
/n ED
/xMilieu ED
/eyewidth ED
/xb ED
/yb ED
/Rcercle ED
/yC ED
/xC ED
positionOEIL
% Adobe PostScript par l'exemple
/TableauxPoints [
0 2 358 {% on dcrit le cercle
    /Angle exch def [
    /xa Rcercle Angle cos mul xC add def
    /ya Rcercle Angle sin mul yC add def
       Coor_Virtuel ]
    } for
    ] def
 TableauxPoints 0 get aload pop moveto
 0 2 178 {
    /compteur exch def
    TableauxPoints compteur get aload pop
    lineto } for
closepath
}
def
%
% Dessin d'un arc de cercle
/DessinArc {
/n ED
/xMilieu ED
/eyewidth ED
/xb ED
/yb ED
/Rcercle ED
/yC ED
/xC ED
positionOEIL
% Adobe PostScript par l'exemple
AngleStop AngleStart gt {/Step 1 def}{/Step -1 def} ifelse
/TableauxPoints [
AngleStart Step AngleStop {% on dcrit l'arc
    /Angle exch def [
    /xa Rcercle Angle cos mul xC add def
    /ya Rcercle Angle sin mul yC add def
       Coor_Virtuel ]
    } for
    ] def
 TableauxPoints 0 get aload pop moveto
 0 1 AngleStop AngleStart sub abs {
    /compteur exch def
    TableauxPoints compteur get aload pop
    lineto } for
}
def

%   dessin de l'oeil
%   pour le refraction
%

/cm { 28.45 Size mul mul} def        %  defini le cm pour la procdure
/eye { gsave
%      Size setlinewidth
      CLW
      0 setgray
      0 0.5 cm moveto
      -0.5 cm 0 lineto
      0 -0.5 cm lineto
      stroke
      newpath
      0.2 cm 1 cm
      moveto
      0.2 cm 1 cm
      0 0
      0.5 cm -1.3 cm
      curveto
      0.4 cm -1.5 cm
      0 -1.5 cm
      -0.1 cm -1.5 cm
      curveto
      -0.2 cm -2 cm
      -0.4 cm -3 cm
      -1.5 cm -2.5 cm
      curveto
      -0.2 cm -2 cm
      moveto
      -1 cm -2 cm
      lineto
      stroke
      newpath
      -0.5 cm 0 0.5 cm 0 360 arc
      clip
      newpath
      0.35 cm 0 0.5 cm 0 360 arc
      closepath
      0 0 1 setrgbcolor
      fill
      newpath
      0.45 cm 0 0.5 cm 0 360 arc
      closepath
      0 1 1 setrgbcolor
      fill
      newpath
      0 setgray
      -0.5 cm 0 0.5 cm -45 45 arc
      stroke
      grestore
 }
def
%
/EyeDraw {
    /xMilieu ED
    /eyewidth ED
    /xb ED
    /yb ED
positionOEIL
  /AngleRot {
  yB2 yB1 sub
  xB2 xB1 sub
  atan }
  def
  gsave
  xb yb translate
  AngleRot 90 sub rotate
  xb xMilieu gt {
  -1 1 scale } if
  eye
  grestore}
def
% rectangle
/DessinFrame {
    /n ED
    /xMilieu ED
    /eyewidth ED
    /xb ED
    /yb ED
    /YC ED
    /XC ED
    /YA ED
    /XA ED
    positionOEIL
    /XB XC def
    /YB YA def
    /XD XA def
    /YD YC def
    /xa XA def
    /ya YA def
    Coor_Virtuel
     moveto
0 0.02 1 { % k
    /K exch def
    /xa K XB mul 1 K sub XA mul add def
    /ya K YB mul 1 K sub YA mul add def
    Coor_Virtuel
    lineto
    } for
0 0.02 1 { % k
    /K exch def
    /xa K XC mul 1 K sub XB mul add def
    /ya K YC mul 1 K sub YB mul add def
    Coor_Virtuel
    lineto
    } for
0 0.02 1 { % k
    /K exch def
    /xa K XD mul 1 K sub XC mul add def
    /ya K YD mul 1 K sub YC mul add def
    Coor_Virtuel
    lineto
    } for
0 0.02 1 { % k
    /K exch def
    /xa K XA mul 1 K sub XD mul add def
    /ya K YA mul 1 K sub YD mul add def
    Coor_Virtuel
    lineto
    } for
    } def
end
